

#include <mega8.h>
#include <ds1621.h>    // DS1621 Thermometer/Thermostat functions
#include <pcf8583.h>
#include <i2c.h> 
#include <lcd.h>
#include <stdio.h>      
#include <delay.h> 

#asm
   .equ __i2c_port=0x12 ;PORTD     // I2C Bus functions
   .equ __sda_bit=1
   .equ __scl_bit=0
#endasm

#asm
   .equ __lcd_port=0x18 ;PORTB     // Alphanumeric LCD Module functions
#endasm

void main(void)
{
//float aa;
unsigned char h,m,s,hs;
int a;
char ss[30];  //  LCD
ACSR=0x80;   // Analog Comparator: Off

i2c_init();  // I2C Bus initialization
ds1621_init(1,50,55,0); // DS1621 Thermometer/Thermostat initialization
rtc_init(0,0); // PCF8583 Real Time Clock initialization
lcd_init(16);  // LCD module initialization
rtc_set_time(0,8,23,0,0); // 
rtc_set_alarm_time(0,8,23,5,0);
rtc_alarm_on(0);

while (1)
      {
      
       a=ds1621_temperature_10(1); 
      
     sprintf(ss,"%i.%u%cC",a*1/10,a*1%10, 0xDF); // 
     lcd_gotoxy(7,1);
     lcd_puts(ss);
          
        
          
     rtc_get_time(0,&h,&m,&s,&hs);
       sprintf(ss,"%i:%i:%i:%i",h,m,s,hs); //ioia?a?aai oaiia?aoo?o
       lcd_gotoxy(1,0);
     lcd_puts(ss);
     
     delay_ms(1000); 
     
      };
}
